* Fix nix-push.

This commit is contained in:
Eelco Dolstra 2003-11-22 20:39:51 +00:00
parent ab0bc4999a
commit 9486dda115
9 changed files with 56 additions and 63 deletions

View File

@ -1,12 +1,13 @@
all-local: nar.sh unnar.sh
install-exec-local:
$(INSTALL) -d $(datadir)/fix/nar
$(INSTALL_DATA) nar.fix $(datadir)/fix/nar
$(INSTALL_PROGRAM) nar.sh $(datadir)/fix/nar
$(INSTALL_DATA) unnar.fix $(datadir)/fix/nar
$(INSTALL_PROGRAM) unnar.sh $(datadir)/fix/nar
$(INSTALL) -d $(datadir)/nix/corepkgs
$(INSTALL) -d $(datadir)/nix/corepkgs/nar
$(INSTALL_DATA) nar.nix $(datadir)/nix/corepkgs/nar
$(INSTALL_PROGRAM) nar.sh $(datadir)/nix/corepkgs/nar
$(INSTALL_DATA) unnar.nix $(datadir)/nix/corepkgs/nar
$(INSTALL_PROGRAM) unnar.sh $(datadir)/nix/corepkgs/nar
include ../../substitute.mk
EXTRA_DIST = nar.fix nar.sh.in unnar.fix unnar.sh.in
EXTRA_DIST = nar.nix nar.sh.in unnar.nix unnar.sh.in

View File

@ -1,8 +0,0 @@
Function(["path"],
Package(
[ ("name", "nar")
, ("build", Relative("nar/nar.sh"))
, ("path", Var("path"))
]
)
)

6
corepkgs/nar/nar.nix Normal file
View File

@ -0,0 +1,6 @@
{system, path}: derivation {
name = "nar";
builder = ./nar.sh;
system = system;
path = path;
}

View File

@ -5,7 +5,7 @@ export PATH=/bin:/usr/bin
echo "packing $path into $out..."
mkdir $out || exit 1
dst=$out/`basename $path`.nar.bz2
@bindir@/nix --dump "$path" | bzip2 > $dst || exit 1
@bindir@/nix-store --dump "$path" | bzip2 > $dst || exit 1
md5=$(md5sum -b $dst | cut -c1-32)
if test $? != 0; then exit 1; fi

View File

@ -1,9 +0,0 @@
Function(["nar", "outPath"],
Package(
[ ("name", "unnar")
, ("outPath", Var("outPath"))
, ("build", Relative("nar/unnar.sh"))
, ("nar", Var("nar"))
]
)
)

7
corepkgs/nar/unnar.nix Normal file
View File

@ -0,0 +1,7 @@
{system, narFile, outPath}: derivation {
name = "unnar";
builder = ./unnar.sh;
system = system;
narFile = narFile;
outPath = outPath;
}

View File

@ -3,4 +3,4 @@
export PATH=/bin:/usr/bin
echo "unpacking $nar to $out..."
bunzip2 < $nar | @bindir@/nix --restore "$out" || exit 1
bunzip2 < $nar | @bindir@/nix-store --restore "$out" || exit 1

View File

@ -7,14 +7,13 @@ my $tmpdir;
do { $tmpdir = tmpnam(); }
until mkdir $tmpdir, 0777;
my $fixfile = "$tmpdir/create-nars.fix";
my $nixfile = "$tmpdir/create-nars.nix";
my $manifest = "$tmpdir/MANIFEST";
END { unlink $manifest; unlink $fixfile; rmdir $tmpdir; }
open FIX, ">$fixfile";
print FIX "[";
my $first = 1;
open NIX, ">$nixfile";
print NIX "[";
my @paths;
@ -24,10 +23,10 @@ foreach my $id (@ARGV) {
# Get all paths referenced by the normalisation of the given
# Nix expression.
system "nix --install $id > /dev/null";
if ($?) { die "`nix --install' failed"; }
system "nix-store --realise $id > /dev/null";
die if ($?);
open PATHS, "nix --query --requisites --include-successors $id 2> /dev/null |" or die "nix -qr";
open PATHS, "nix-store --query --requisites --include-successors $id 2> /dev/null |" or die;
while (<PATHS>) {
chomp;
die "bad: $_" unless /^\//;
@ -35,34 +34,31 @@ foreach my $id (@ARGV) {
}
close PATHS;
# For each path, create a Fix expression that turns the path into
# For each path, create a Nix expression that turns the path into
# a Nix archive.
foreach my $path (@paths) {
die unless ($path =~ /\/[0-9a-z]{32}.*$/);
print "$path\n";
# Construct a Fix expression that creates a Nix archive.
my $fixexpr =
"Call(IncludeFix(\"nar/nar.fix\"), " .
"[ (\"path\", Closure([\"$path\"], [(\"$path\", [])]))" .
"])";
print FIX "," unless ($first);
$first = 0;
print FIX $fixexpr;
die unless ($path =~ /\/[0-9a-z]{32}.*$/);
print "$path\n";
# Construct a Nix expression that creates a Nix archive.
my $nixexpr =
"((import @datadir@/nix/corepkgs/nar/nar.nix) " .
# !!! $path should be represented as a closure
"{path = \"$path\"; system = \"@host@\"}) ";
print NIX $nixexpr;
}
}
print FIX "]";
close FIX;
print NIX "]";
close NIX;
# Instantiate a Nix expression from the Fix expression.
# Instantiate a store expression from the Nix expression.
my @nids;
print STDERR "running fix...\n";
open NIDS, "fix $fixfile |" or die "cannot run fix";
print STDERR "instantiating Nix expression...\n";
open NIDS, "nix-instantiate $nixfile |" or die "cannot run nix-instantiate";
while (<NIDS>) {
chomp;
die unless /^\//;
@ -71,13 +67,13 @@ while (<NIDS>) {
close NIDS;
# Realise the Nix expression.
# Realise the store expression.
print STDERR "creating archives...\n";
system "nix --install -v @nids > /dev/null";
if ($?) { die "`nix --install' failed"; }
system "nix-store --realise -v @nids > /dev/null";
if ($?) { die "`nix --realise' failed"; }
my @narpaths;
open NIDS, "nix --query --list @nids |" or die "cannot run nix";
open NIDS, "nix-store --query --list @nids |" or die "cannot run nix";
while (<NIDS>) {
chomp;
die unless (/^\//);
@ -120,13 +116,13 @@ for (my $n = 0; $n < scalar @paths; $n++) {
print MANIFEST " MD5: $hash\n";
if ($storepath =~ /\.nix$/) {
open PREDS, "nix --query --predecessors $storepath |" or die "cannot run nix";
while (<PREDS>) {
chomp;
die unless (/^\//);
print MANIFEST " SuccOf: $_\n";
}
close PREDS;
open PREDS, "nix-store --query --predecessors $storepath |" or die "cannot run nix";
while (<PREDS>) {
chomp;
die unless (/^\//);
print MANIFEST " SuccOf: $_\n";
}
close PREDS;
}
print MANIFEST "}\n";

View File

@ -53,8 +53,8 @@ static void printNixExpr(EvalState & state, Expr e)
}
}
if (ATgetType(e) == AT_LIST) {
for (ATermIterator i((ATermList) e); i; ++i)
if (atMatch(m, e) >> "List" >> es) {
for (ATermIterator i(es); i; ++i)
printNixExpr(state, evalExpr(state, *i));
return;
}